var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
define(["require", "exports", "system_lib/Metadata", "system_lib/Feed", "system/SimpleHTTP", "lib/JSEncrypt", "lib/webtoolkit_SHA256", "lib/webtoolkit_base64"], function (require, exports, Metadata_1, feed, SimpleHTTP_1, JSEncrypt_1, webtoolkit_SHA256_1, webtoolkit_base64_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.ServiceAccountCalendarFeed = void 0;
    var scopes = 'https://www.googleapis.com/auth/calendar.readonly';
    var credentials = {
        YOUR: YOUR, CREDENTIALS: CREDENTIALS, HERE: HERE
    };
    var ServiceAccountCalendarFeed = (function (_super) {
        __extends(ServiceAccountCalendarFeed, _super);
        function ServiceAccountCalendarFeed(env) {
            var _this = _super.call(this, env) || this;
            _this.establishFeed(new Cal("TodayPast", -1));
            _this.establishFeed(new Cal("Today", 0));
            _this.establishFeed(new Cal("Tomorrow", 24));
            _this.establishFeed(new Cal("TwoDays", 48));
            return _this;
        }
        return ServiceAccountCalendarFeed;
    }(feed.Feed));
    exports.ServiceAccountCalendarFeed = ServiceAccountCalendarFeed;
    var Cal = (function () {
        function Cal(feedName, timeOffset) {
            this.listType = ListItem;
            this.itemType = DetailsItem;
            this.name = feedName;
            this.timeOffset = timeOffset;
        }
        Cal.prototype.getList = function (spec) {
            var _this = this;
            var timeNow = Math.floor(Date.now() / 1000);
            var jwtHeader = JSON.stringify({ "alg": "RS256", "typ": "JWT" });
            var jwtClaim = JSON.stringify({
                "iss": credentials.client_email,
                "scope": scopes,
                "aud": "https://oauth2.googleapis.com/token",
                "exp": timeNow + 3600,
                "iat": timeNow
            });
            var sign = new JSEncrypt_1.JSEncrypt({});
            sign.setPublicKey(credentials.private_key);
            var jwtSignature = sign.sign(webtoolkit_base64_1.Base64.encode(jwtHeader)
                .replace(/=+$/, '')
                .replace(/\//g, '_')
                .replace(/\+/g, '-') +
                "." +
                webtoolkit_base64_1.Base64.encode(jwtClaim)
                    .replace(/=+$/, '')
                    .replace(/\//g, '_')
                    .replace(/\+/g, '-'), webtoolkit_SHA256_1.SHA256, "sha256");
            var assertionString = webtoolkit_base64_1.Base64.encode(jwtHeader)
                .replace(/=+$/, '')
                .replace(/\//g, '_')
                .replace(/\+/g, '-') +
                "." +
                webtoolkit_base64_1.Base64.encode(jwtClaim)
                    .replace(/=+$/, '')
                    .replace(/\//g, '_')
                    .replace(/\+/g, '-') +
                "." +
                jwtSignature.toString()
                    .replace(/=+$/, '')
                    .replace(/\//g, '_')
                    .replace(/\+/g, '-');
            var timeBase = new Date();
            if (this.timeOffset != 0) {
                timeBase.setUTCHours(this.timeOffset, 0, 0, 0);
            }
            var timeMinString = timeBase.toISOString();
            if (this.timeOffset != -1) {
                timeBase.setUTCHours(24, 0, 0, 0);
            }
            else {
                timeBase = new Date();
            }
            var timeMaxString = timeBase.toISOString();
            return SimpleHTTP_1.SimpleHTTP
                .newRequest("https://oauth2.googleapis.com/token", { interpretResponse: true })
                .setTimeout(25)
                .post("grant_type=urn%3Aietf%3Aparams%3Aoauth%3Agrant-type%3Ajwt-bearer&assertion=" +
                encodeURI(assertionString), "application/x-www-form-urlencoded")
                .then(function (response) {
                return SimpleHTTP_1.SimpleHTTP
                    .newRequest("https://content.googleapis.com/calendar/v3/calendars/" +
                    encodeURI(spec.spotParameters.calendarId.toString()) +
                    "/events?orderBy=startTime&showDeleted=false&maxResults=100&singleEvents=true&timeMin=" +
                    timeMinString +
                    "&timeMax=" +
                    timeMaxString +
                    "&access_token=" +
                    response.interpreted.access_token, { interpretResponse: true })
                    .setTimeout(25)
                    .get()
                    .then(function (response2) { return _this.processList(response2.interpreted.items, Math.round(_this.timeOffset / 24), Date.parse(timeMaxString)); });
            });
        };
        Cal.prototype.getDetails = function (spec) {
            return this.processDetails(this.listResponse[spec.index]);
        };
        Cal.prototype.processList = function (list, currentDay, maxTime) {
            this.listResponse = list;
            var listItems = [];
            for (var _i = 0, list_1 = list; _i < list_1.length; _i++) {
                var item = list_1[_i];
                var startTimeFormatted = item.start["dateTime"] != undefined ?
                    new Date(Date.parse(item.start["dateTime"])).toTimeString() : "00:00";
                var endTimeFormatted = item.end["dateTime"] != undefined ?
                    new Date(Date.parse(item.end["dateTime"])).toTimeString() : "24:00";
                if (maxTime >= Date.parse(item.end["dateTime"]) || currentDay != 0) {
                    listItems.push(new ListItem(item.id, item.summary, startTimeFormatted.split(":")[0] + ":" + startTimeFormatted.split(":")[1], endTimeFormatted.split(":")[0] + ":" + endTimeFormatted.split(":")[1]));
                }
            }
            return { items: listItems };
        };
        Cal.prototype.processDetails = function (item) {
            var startTimeFormatted = item.start["dateTime"] != undefined ?
                new Date(Date.parse(item.start["dateTime"])).toTimeString() : "00:00";
            var endTimeFormatted = item.end["dateTime"] != undefined ?
                new Date(Date.parse(item.end["dateTime"])).toTimeString() : "24:00";
            return {
                id: item.id,
                title: item.summary != undefined ? item.summary : "(No title available)",
                description: item.description,
                startTime: startTimeFormatted.split(":")[0] + ":" + startTimeFormatted.split(":")[1],
                endTime: endTimeFormatted.split(":")[0] + ":" + endTimeFormatted.split(":")[1],
                htmlLink: item.htmlLink.split("?eid=")[1],
                location: item.location != undefined ? item.location : "--"
            };
        };
        return Cal;
    }());
    var ListItem = (function () {
        function ListItem(id, title, start, end) {
            this.id = id;
            this.title = title;
            this.startTime = start;
            this.endTime = end;
        }
        __decorate([
            Metadata_1.id("Uniquely identifying this feed item"),
            __metadata("design:type", String)
        ], ListItem.prototype, "id", void 0);
        __decorate([
            Metadata_1.field("Title of the item"),
            __metadata("design:type", String)
        ], ListItem.prototype, "title", void 0);
        __decorate([
            Metadata_1.field("Event start time"),
            __metadata("design:type", String)
        ], ListItem.prototype, "startTime", void 0);
        __decorate([
            Metadata_1.field("Event end time"),
            __metadata("design:type", String)
        ], ListItem.prototype, "endTime", void 0);
        return ListItem;
    }());
    var DetailsItem = (function (_super) {
        __extends(DetailsItem, _super);
        function DetailsItem(id, description, title, start, end, htmlLink, location) {
            var _this = this;
            _this = _super.call(this, id, title, start, end) || this,
                _this.description = description;
            _this.htmlLink = htmlLink;
            _this.location = location;
            return _this;
        }
        __decorate([
            Metadata_1.field("Event Description"),
            __metadata("design:type", String)
        ], DetailsItem.prototype, "description", void 0);
        __decorate([
            Metadata_1.field("Event Id"),
            __metadata("design:type", String)
        ], DetailsItem.prototype, "htmlLink", void 0);
        __decorate([
            Metadata_1.field("Location for event"),
            __metadata("design:type", String)
        ], DetailsItem.prototype, "location", void 0);
        return DetailsItem;
    }(ListItem));
});
