define(["require", "exports", "jsbn_prng4"], function (require, exports, jsbn_prng4_1) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.SecureRandom = void 0;
    var rng_state;
    var rng_pool = null;
    var rng_pptr;
    if (rng_pool == null) {
        rng_pool = [];
        rng_pptr = 0;
    }
    function rng_get_byte() {
        if (rng_state == null) {
            rng_state = jsbn_prng4_1.prng_newstate();
            while (rng_pptr < jsbn_prng4_1.rng_psize) {
                var random = Math.floor(65536 * Math.random());
                rng_pool[rng_pptr++] = random & 255;
            }
            rng_state.init(rng_pool);
            for (rng_pptr = 0; rng_pptr < rng_pool.length; ++rng_pptr) {
                rng_pool[rng_pptr] = 0;
            }
            rng_pptr = 0;
        }
        return rng_state.next();
    }
    var SecureRandom = (function () {
        function SecureRandom() {
        }
        SecureRandom.prototype.nextBytes = function (ba) {
            for (var i = 0; i < ba.length; ++i) {
                ba[i] = rng_get_byte();
            }
        };
        return SecureRandom;
    }());
    exports.SecureRandom = SecureRandom;
});
