define(["require", "exports"], function (require, exports) {
    "use strict";
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.cbit = exports.lbit = exports.op_andnot = exports.op_xor = exports.op_or = exports.op_and = exports.int2char = void 0;
    var BI_RM = "0123456789abcdefghijklmnopqrstuvwxyz";
    function int2char(n) {
        return BI_RM.charAt(n);
    }
    exports.int2char = int2char;
    function op_and(x, y) {
        return x & y;
    }
    exports.op_and = op_and;
    function op_or(x, y) {
        return x | y;
    }
    exports.op_or = op_or;
    function op_xor(x, y) {
        return x ^ y;
    }
    exports.op_xor = op_xor;
    function op_andnot(x, y) {
        return x & ~y;
    }
    exports.op_andnot = op_andnot;
    function lbit(x) {
        if (x == 0) {
            return -1;
        }
        var r = 0;
        if ((x & 0xffff) == 0) {
            x >>= 16;
            r += 16;
        }
        if ((x & 0xff) == 0) {
            x >>= 8;
            r += 8;
        }
        if ((x & 0xf) == 0) {
            x >>= 4;
            r += 4;
        }
        if ((x & 3) == 0) {
            x >>= 2;
            r += 2;
        }
        if ((x & 1) == 0) {
            ++r;
        }
        return r;
    }
    exports.lbit = lbit;
    function cbit(x) {
        var r = 0;
        while (x != 0) {
            x &= x - 1;
            ++r;
        }
        return r;
    }
    exports.cbit = cbit;
});
